GuardedObject (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.security, class: GuardedObject
Keywords: java.security.GuardedObject class

# Class GuardedObject

java.lang.Object
java.security.GuardedObject

All Implemented Interfaces:
  `Serializable`

public class GuardedObject extends Object implements Serializable
A GuardedObject is an object that is used to protect access to another object.

A GuardedObject encapsulates a target object and a Guard object, such that access to the target object is possible only if the Guard object allows it. Once an object is encapsulated by a GuardedObject, access to that object is controlled by the `getObject` method, which invokes the `checkGuard` method on the Guard object that is guarding access. If access is not allowed, an exception is thrown.

Since:
  1.2
See Also:
  - `Guard`
  - `Permission`
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GuardedObject(Object object, Guard guard)`
  Constructs a GuardedObject using the specified object and guard.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `getObject()`
  Retrieves the guarded object, or throws an exception if access to the guarded object is denied by the guard.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### GuardedObject

    public GuardedObject(Object object, Guard guard)
    Constructs a GuardedObject using the specified object and guard. If the Guard object is `null`, then no restrictions will be placed on who can access the object.
    Parameters:
      `object` - the object to be guarded.
      `guard` - the Guard object that guards access to the object.

- ## Method Details

  - ### getObject

    public Object getObject() throws SecurityException
    Retrieves the guarded object, or throws an exception if access to the guarded object is denied by the guard.
    Returns:
      the guarded object.
    Throws:
      `SecurityException` - if access to the guarded object is denied.